<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: stats-global-advertiser.php 3391 2005-06-20 17:09:07Z radek $
*/

// Require the initialisation file
require_once '../../init.php';

// Required files
require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/www/admin/lib-statistics.inc.php';
require_once MAX_PATH . '/lib/max/other/common.php';
require_once MAX_PATH . '/lib/max/Admin_DA.php';
require_once MAX_PATH . '/lib/max/other/html.php';
require_once MAX_PATH . '/lib/max/other/stats.php';

// Security check
phpAds_checkAccess(phpAds_Admin + phpAds_Agency);

// Get input variables
$pref = $GLOBALS['_MAX']['PREF'];
$period         = MAX_getStoredValue('period', 'today');
$hideinactive   = MAX_getStoredValue('hideinactive', ($pref['gui_hide_inactive'] == 't'));
$listorder      = MAX_getStoredValue('listorder', 'name');
$orderdirection = MAX_getStoredValue('orderdirection', 'up');
$aNodes         = MAX_getStoredArray('nodes', array());
$expand         = MAX_getValue('expand', '');
$collapse       = MAX_getValue('collapse');

// Adjust which nodes are opened closed...
MAX_adjustNodes($aNodes, $expand, $collapse);

// Display navigation
phpAds_PageHeader('2.1');
phpAds_ShowSections(array('2.1', '2.4', '2.2'));

// Initialise some parameters
$pageName = basename($_SERVER['PHP_SELF']);
$tabindex = 1;
$advertisersHidden = 0;

// Display date filter form
$aDates = MAX_getDatesByPeriod($period);
MAX_displayDateSelectionForm($period, $aDates, $pageName, $tabindex);

phpAds_ShowBreak();

$aParams = array();
if (!phpAds_isUser(phpAds_Admin)) {
    $aParams['agency_id'] = phpAds_getAgencyID();
}

// Get the advertiser stats...
$aAdvertisers = Admin_DA::fromCache('getAdvertisersStats', $aParams + $aDates);

// Build the advertisers array
if (!empty($aAdvertisers)) {
    echo "
        <br /><br />
        <table border='0' width='100%' cellpadding='0' cellspacing='0'>";
    MAX_displayStatsHeader($pageName, $listorder, $orderdirection);

    // Variable to determine if the row should be grey or white...
    $i=0;

	$totalRequests = 0;
    $totalViews = 0;
    $totalClicks = 0;
    $totalConversions = 0;
    // Loop through advertisers
    MAX_sortArray($aAdvertisers, ($listorder == 'id' ? 'advertiser_id' : $listorder), $orderdirection == 'up');
    foreach($aAdvertisers as $advertiserId => $advertiser) {
        $advertiserActive = $advertiser['active'] == 't' && ($advertiser['sum_requests'] > 0 || $advertiser['sum_views'] > 0 || $advertiser['sum_clicks'] > 0 || $advertiser['sum_conversions'] > 0);
        $advertiserRequests = phpAds_formatNumber($aAdvertisers[$advertiserId]['sum_requests']);
        $advertiserViews = phpAds_formatNumber($aAdvertisers[$advertiserId]['sum_views']);
        $advertiserClicks = phpAds_formatNumber($aAdvertisers[$advertiserId]['sum_clicks']);
        $advertiserConversions = phpAds_formatNumber($aAdvertisers[$advertiserId]['sum_conversions']);
        $advertiserCtr = phpAds_buildRatioPercentage($aAdvertisers[$advertiserId]['sum_clicks'], $aAdvertisers[$advertiserId]['sum_views']);
        $advertiserSr = phpAds_buildRatioPercentage($aAdvertisers[$advertiserId]['sum_conversions'], $aAdvertisers[$advertiserId]['sum_clicks']);            
        $advertiserExpanded = MAX_isExpanded($advertiserId, $expand, $aNodes, 'a');
        $advertiserIcon = MAX_getEntityIcon('advertiser', $advertiserActive);
            
        $totalRequests += $advertiser['sum_requests'];
        $totalViews += $advertiser['sum_views'];
        $totalClicks += $advertiser['sum_clicks'];
        $totalConversions += $advertiser['sum_conversions'];

        if (!$hideinactive || $advertiserActive) {
            $bgcolor = ($i++ % 2 == 0) ? " bgcolor='#F6F6F6'" : '';
            echo "
        <tr height='25'$bgcolor>
            <td>";
            if (!empty($advertiser['num_children'])) {
                if ($advertiserExpanded) {
                    echo "&nbsp;<a href='$pageName?collapse=a$advertiserId'><img src='images/triangle-d.gif' align='absmiddle' border='0'></a>&nbsp;";
                } else {
                    echo "&nbsp;<a href='$pageName?expand=a$advertiserId'><img src='images/$phpAds_TextDirection/triangle-l.gif' align='absmiddle' border='0'></a>&nbsp;";
                }
            }
            else
            echo "&nbsp;<img src='images/spacer.gif' height='16' width='16'>&nbsp;";
            echo "
                <img src='$advertiserIcon' align='absmiddle'>&nbsp;
                <a href='stats-advertiser-history.php?clientid=$advertiserId'>{$advertiser['name']}</a>
            </td>
            <td align='$phpAds_TextAlignRight'>$advertiserId</td>
            <td align='$phpAds_TextAlignRight'>$advertiserRequests</td>
            <td align='$phpAds_TextAlignRight'>$advertiserViews</td>
            <td align='$phpAds_TextAlignRight'>$advertiserClicks</td>
            <td align='$phpAds_TextAlignRight'>$advertiserCtr</td>
            <td align='$phpAds_TextAlignRight'><a href='stats-conversions.php?clientid=$advertiserId&period=$period'><u>$advertiserConversions</u></a></td>
            <td align='$phpAds_TextAlignRight'>$advertiserSr</td>
        </tr>";

            if ($advertiserExpanded) {
                echo "
        <tr height='1'>
            <td$bgcolor><img src='images/spacer.gif' width='1' height='1'></td>
            <td colspan='7' bgcolor='#888888'><img src='images/break-l.gif' height='1' width='100%'></td>
        </tr>";


                // Loop through campaigns
                $aParams = array('advertiser_id' => $advertiserId);
                $aPlacements = Admin_DA::fromCache('getPlacementsStats', $aParams + $aDates);
                MAX_sortArray($aPlacements, ($listorder == 'id' ? 'placement_id' : $listorder), $orderdirection == 'up');
                foreach ($aPlacements as $campaignId => $campaign) {
                    $campaignRequests = phpAds_formatNumber($campaign['sum_requests']);
                    $campaignViews = phpAds_formatNumber($campaign['sum_views']);
                    $campaignClicks = phpAds_formatNumber($campaign['sum_clicks']);
                    $campaignConversions = phpAds_formatNumber($campaign['sum_conversions']);
                    $campaignCtr = phpAds_buildRatioPercentage($campaign['sum_clicks'], $campaign['sum_views']);
                    $campaignSr = phpAds_buildRatioPercentage($campaign['sum_conversions'], $campaign['sum_clicks']);
                    $campaignExpanded = MAX_isExpanded($campaignId, $expand, $aNodes, 'c');
                    $campaignIcon = MAX_getEntityIcon('placement', $campaign['active']=='t');

                    echo "
        <tr height='25'$bgcolor>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                    if (!empty($campaign['num_children'])) {
                        if ($campaignExpanded)
                        echo "
                <a href='$pageName?collapse=c$campaignId'><img src='images/triangle-d.gif' align='absmiddle' border='0'></a>&nbsp;";
                        else
                        echo "
                <a href='$pageName?expand=c$campaignId'><img src='images/$phpAds_TextDirection/triangle-l.gif' align='absmiddle' border='0'></a>&nbsp;";
                    }
                    else
                    echo "
                <img src='images/spacer.gif' height='16' width='16' align='absmiddle'>&nbsp;";

                    echo "
                <img src='$campaignIcon' align='absmiddle'>&nbsp;";

                    echo "
                <a href='stats-campaign-history.php?clientid=$advertiserId&campaignid=$campaignId'>{$campaign['name']}</a>
            </td>
            <td align='$phpAds_TextAlignRight'>$campaignId</td>
            <td align='$phpAds_TextAlignRight'>$campaignRequests</td>
            <td align='$phpAds_TextAlignRight'>$campaignViews</td>
            <td align='$phpAds_TextAlignRight'>$campaignClicks</td>
            <td align='$phpAds_TextAlignRight'>$campaignCtr</td>
            <td align='$phpAds_TextAlignRight'><a href='stats-conversions.php?clientid=$advertiserId&campaignid=$campaignId&period=$period'><u>$campaignConversions</u></a></td>
            <td align='$phpAds_TextAlignRight'>$campaignSr</td>
        </tr>";
                    if (!empty($campaign['num_children']) && $campaignExpanded) {


                        // Loop through banners
                        $aParams = array('placement_id' => $campaignId);
                        $aAds = Admin_DA::fromCache('getAdsStats', $aParams + $aDates);
                        MAX_sortArray($aAds, ($listorder == 'id' ? 'ad_id' : $listorder), $orderdirection == 'up');
                        foreach ($aAds as $bannerId => $banner) {
                            $bannerRequests = phpAds_formatNumber($banner['sum_requests']);
                            $bannerViews = phpAds_formatNumber($banner['sum_views']);
                            $bannerClicks = phpAds_formatNumber($banner['sum_clicks']);
                            $bannerConversions = phpAds_formatNumber($banner['sum_conversions']);
                            $bannerCtr = phpAds_buildRatioPercentage($banner['sum_clicks'], $banner['sum_views']);
                            $bannerSr = phpAds_buildRatioPercentage($banner['sum_conversions'], $banner['sum_clicks']);
                            $bannerIcon = MAX_getEntityIcon('ad', ($banner['active'] == 't' && $campaign['active'] == 't'), $banner['type']);

                            echo "
        <tr height='1'>
            <td$bgcolor><img src='images/spacer.gif' width='1' height='1'></td>
            <td colspan='7' bgcolor='#888888'><img src='images/break-l.gif' height='1' width='100%'></td>
        </tr>
        <tr height='25'$bgcolor>
            <td height='25'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                            echo "<img src='$bannerIcon' align='absmiddle'>&nbsp;";
                            echo "&nbsp;<a href='stats-banner-history.php?clientid=$advertiserId&campaignid=$campaignId&bannerid=$bannerId'>{$banner['name']}</a></td>
            <td align='$phpAds_TextAlignRight'>$bannerId</td>
            <td align='$phpAds_TextAlignRight'>$bannerRequests</td>
            <td align='$phpAds_TextAlignRight'>$bannerViews</td>
            <td align='$phpAds_TextAlignRight'>$bannerClicks</td>
            <td align='$phpAds_TextAlignRight'>$bannerCtr</td>
            <td align='$phpAds_TextAlignRight'><a href='stats-conversions.php?clientid=$advertiserId&campaignid=$campaignId&bannerid=$bannerId&period=$period'><u>$bannerConversions</u></a></td>
            <td align='$phpAds_TextAlignRight'>$bannerSr</td>
        </tr>";
                        }
                    }
                }
            }
            echo "
            <tr height='1'><td colspan='8' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
        } else {
            $advertisersHidden++;
        }
    }

    // Total
    echo "
        <tr height='25'$bgcolor>
            <td>&nbsp;&nbsp;<b>$strTotal</b></td>
            <td>&nbsp;</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($totalRequests)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($totalViews)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($totalClicks)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_buildRatioPercentage($totalClicks, $totalViews)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($totalConversions)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_buildRatioPercentage($totalConversions, $totalClicks)."</td>
        </tr>
        <tr height='1'>
            <td colspan='8' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td>
        </tr>
        <tr>
            <td colspan='4' align='$phpAds_TextAlignLeft' nowrap>";

    if ($hideinactive == true) {
        echo "&nbsp;&nbsp;<img src='images/icon-activate.gif' align='absmiddle' border='0'>&nbsp;<a href='$pageName?period=$period&amp;hideinactive=0'>$strShowAll</a>&nbsp;&nbsp;|&nbsp;&nbsp;$advertisersHidden $strInactiveAdvertisersHidden";
    } else {
        echo "&nbsp;&nbsp;<img src='images/icon-hideinactivate.gif' align='absmiddle' border='0'>&nbsp;<a href='$pageName?period=$period&amp;hideinactive=1'>$strHideInactiveAdvertisers</a>";
    }

    echo "
            </td>
            <td colspan='4' align='$phpAds_TextAlignRight' nowrap><img src='images/triangle-d.gif' align='absmiddle' border='0'>&nbsp;<a href='$pageName?period=$period&amp;expand=all' accesskey='$keyExpandAll'>$strExpandAll</a>&nbsp;&nbsp;|&nbsp;&nbsp;<img src='images/$phpAds_TextDirection/triangle-l.gif' align='absmiddle' border='0'>&nbsp;<a href='$pageName?period=$period&amp;expand=none' accesskey='$keyCollapseAll'>$strCollapseAll</a>&nbsp;&nbsp;</td>
        </tr>
        </table>
        <br /><br />";
} else {
    echo "
        <br /><br /><div class='errormessage'><img class='errormessage' src='images/info.gif' width='16' height='16' border='0' align='absmiddle'>$strNoStats</div>";
}

// Store preferences
$session['prefs'][$pageName]['hideinactive'] = $hideinactive;
$session['prefs'][$pageName]['listorder'] = $listorder;
$session['prefs'][$pageName]['nodes'] = implode (",", $aNodes);
$session['prefs'][$pageName]['orderdirection'] = $orderdirection;
$session['prefs'][$pageName]['period'] = $period;
phpAds_SessionDataStore();

// Display page footer
phpAds_PageFooter();

?>
